function [statemap, varargout] = propsim(IC, Param, iter)


T = Param(1);
W = Param(2);
k = Param(3);
w = sqrt(9.81/0.4);

bz = W/(exp(w*T)+1) * (1 - k/2 * (exp(w*T) - 1));

A = [cosh(w*T) sinh(w*T)/w 0; w*sinh(w*T) cosh(w*T) 0; 0 0 1];
B = [k (k+1)/w -k; 0 -1 0; k+1 (k+1)/w -(k+1)];
statemap = IC;
inertmap = IC;
uz = 0;
wz = 0;

for i = 1:iter
    uz = uz + (-1)^i * wz;

    zi = B*A*transpose(statemap(i, :)) + [bz; 0; bz];

    zt = A*transpose(statemap(i, :));

    zinert = (-1)^(i-1) * zt(1) + uz;
    zcinert = (-1)^(i-1) + uz;

    statemap(i+1, :) = transpose(zi);
    inertmap(i+1, :) = [zinert, (-1)^i * zi(2), zcinert];

    wz = (k+1)*exp(w*T)*statemap(i, 1) + (k+1)*exp(w*T)*statemap(i, 2)/w - k * statemap(i, 3) + bz;

    coplist(i) = uz;
    wlist(i) = wz;
end

coplist = [coplist, 0];

varargout = {wlist, inertmap, coplist};


end