

L = 0.8;
w = sqrt(9.81/(L/2));
T = 0.5;
S = 0.5;
W = 0.1;
%%
[conv, div] = scattershot([-0.1, 0.2, 0.001, -0.3, 0.3, 0.003], [T, W, L], 5);
%%
[V, D] = eigs([sinh(w*T), 1/w * cosh(w*T); -w*sinh(w*T), -cosh(w*T)]);

bz = W/(exp(w*T)+1);
bx = S/(exp(w*T)-1);

Xstar = -bx/2 * (exp(w*T)-1);
Vxstar = bx*w/2 * (exp(w*T)+1);

Zstar = bz/2 * (exp(w*T)+1);
Vzstar = -bz*w/2 * (exp(w*T)-1);

%%

xrange = -0.5:0.005:0.5;
yrange1 = -w*xrange - w*bz*exp(-w*T);
yrange2 = -w*xrange - w*bz*exp(-w*T) + L*w*exp(-w*T);

yrange3 = V(1, 2)/V(1,1) * (xrange - Zstar) + Vzstar;
yrange4 = V(2, 2)/V(2,1) * (xrange - Zstar) + Vzstar;

hold on
plot(Zstar, Vzstar, 'k.', 'MarkerSize', 10)
hold off
hold on
plot(xrange, yrange1, 'b', xrange, yrange2, 'b', 'LineWidth', 1)
hold off
%hold on
%plot(xrange, yrange3, 'm-.', xrange, yrange4, 'm--', 'LineWidth', 1)
%plot(xrange, yrange4, 'm--', 'LineWidth', 1)
%hold off


%axis tight
xlim([-0.1, 0.2])
ylim([-0.3, 0.3])


legend('Converge', 'Diverge', 'Fixed Point', 'Analytical Boundaries')%, 'IP Eigenvectors')
%%
figure(4)

plot(Zstar, Vzstar, 'k.', 'MarkerSize', 10)
hold on
plot(xrange, yrange1, 'b', xrange, yrange2, 'b', 'LineWidth', 1)
hold off
yrange3 = coth(w*T)/w * (xrange - Zstar) + Vzstar;
yrange4 = 1/w * (xrange - Zstar) + Vzstar;
hold on
plot(xrange, yrange3, 'g-.', xrange, yrange4, 'r-.', 'LineWidth', 1)
hold off

%%
figure(5)
try
    clf(5)
catch
end
L = 0.8;
w = sqrt(9.81/(L/2));
T = 0.5;
S = 0.5;
W = 0.1;
bz = W/(exp(w*T)+1);

for bz1 = [bz - 0.5:0.1:bz + 0.5, bz]
xrange = -0.5:0.005:0.5;
yrange1 = -w*xrange - w*bz1*exp(-w*T);
yrange2 = -w*xrange - w*bz1*exp(-w*T) + L*w*exp(-w*T);

if bz1 == bz
plot(xrange, yrange1, 'b', xrange, yrange2, 'b')
hold all
elseif bz1 < bz
plot(xrange, yrange1, 'Color', [.7, .7 .7])
hold all
plot(xrange, yrange2, 'Color', [.7, .7 .7])
hold all
else
plot(xrange, yrange1, 'k')
hold all
plot(xrange, yrange2, 'k')
hold all
end


end


%%

zc = -0.59;
k = 1.2/(exp(w*T) - 1);
bif = (exp(w*T)*(k - exp(-w*T)*(k+1)));
bz = W/((exp(w*T)+1)/(1 - k/2*(exp(w*T) - 1)));
iter = 2;
% const = bz/(k - k*exp(w*T) + 2);
% Zstar = const * (exp(w*T) + 1);
% VZstar = -const * (w*(exp(w*T) - 1));
% w1 = (k+1) *exp(w*T) * Zstar + (k+1)/w * exp(w*T) * VZstar - k * zc + bz;
% zc1 = (k+1) * exp(w*T) * (Zstar + VZstar/w) - (k+1) * zc;
% z1 = (k * cosh(w*T) + (k + 1) * sinh(w*T)) * Zstar + ((k+1) * cosh(w*T) + k * sinh(w*T)) * VZstar/w - k * zc;
% vz1 = -w*sinh(w*T) * Zstar - cosh(w*T) * VZstar;
% w2 = (k+1) *exp(w*T) * z1 + (k+1)/w * exp(w*T) * vz1 - k * zc1 + bz;

propshot([-0.1, 0.2, 0.002, -0.3, 0.3, 0.005], [T, W, L, zc, k], iter);

Gz = bz/k* (1 + exp(-w*T))/(1-exp(-w*T));
Hz = (1 + exp(-w*T))/(1 - exp(-w*T)) * bz/k + L - L/(k * (exp(w*T) - 1));

%%
% figure(5)
% k = 0.15;
F0 = k/(k+1) * exp(-w*T);
G0 = -bz/(k+1) * exp(-w*T);
H0 = (L-bz)/(k+1) * exp(-w*T);
Gstar = bz*(exp(-w*T) - 1)/((k - exp(-w*T) * (k+1)) * exp(w*T) - 1);
% zc = 0.1;

%{
for zcn = zc
up = F0 * zcn + H0;
down = F0 * zcn + G0;
xrange = -0.5:0.005:0.5;
yrange1 = -w*xrange + w*down;
yrange2 = -w*xrange + w*up;

hold on
plot(xrange, yrange1, 'b', xrange, yrange2, 'b', 'LineWidth', 1)
hold off

end
%}


B = [];
C = [];
G = [];
H = [];
G(1) = G0;
H(1) = H0;
B(1) = F0 * zc + G0;
C(1) = F0 * zc + H0;

if iter > 1
Fn = exp(-w*T);
G1 = (bz * (F0 - 1) + G0)/(exp(w*T)*(k - F0*(k+1)));
H1 = (bz * (F0 - 1) + H0)/(exp(w*T)*(k - F0*(k+1)));

B(2) = Fn * zc + G1;
C(2) = Fn * zc + H1;
G(2) = G1;
H(2) = H1;

Gtemp = G1;
Htemp = H1;
end

if iter > 2
for i = 1:iter-1

Gtemp = (bz * (Fn - 1) + Gtemp)/(exp(w*T) * (k - Fn *(k+1)));
Htemp = (bz * (Fn - 1) + Htemp)/(exp(w*T) * (k - Fn *(k+1)));
G(i+2) = Gtemp;
H(i+2) = Htemp;
Btemp = Fn * zc + Gtemp;
Ctemp = Fn * zc + Htemp;

if Btemp < Ctemp
B(i + 2) = Btemp;
C(i + 2) = Ctemp;
elseif Ctemp < Btemp
B(i + 2) = Ctemp;
C(i + 2) = Btemp;
end
end
end
xrange = -0.5:0.005:0.5;
yrange1 = -w*xrange + w*max(B);
yrange2 = -w*xrange + w*min(C);

hold on
plot(xrange, yrange1, 'b', xrange, yrange2, 'b', 'LineWidth', 1)
hold off
%hold on
%plot(xrange, yrange3, 'm-.', xrange, yrange4, 'm--', 'LineWidth', 1)
%plot(xrange, yrange4, 'm--', 'LineWidth', 1)
%hold off
%axis tight
xlim([-0.1, 0.2])
ylim([-0.3, 0.3])

legend('Converge', 'Diverge', 'Fixed Point', 'Analytical Boundaries')


%


%%

% [statemap5, inertmap5] = simplesim([Xstar, -0.05, Vxstar, -0.2], [T, W, L/2], 3);
% 
% figure(8)
% plot(inertmap5(:, 2), inertmap5(:, 1), 'r')
% hold on
% plot(inertmap5(:, 6), inertmap5(:, 5), 'r*')
% hold off
% 
% [statemap6, inertmap6] = simplesim([Xstar, 0.073, Vxstar, -0.0135], [T, W, L/2], 3);
% 
% hold on
% plot(inertmap6(:, 2), inertmap6(:, 1), 'b')
% hold off
% hold on
% plot(inertmap6(:, 6), inertmap6(:, 5), 'b*')
% hold off
% 
% [statemap7, inertmap7] = simplesim([Xstar, 0.073, Vxstar, -0.05], [T, W, L/2], 5);
% 
% hold on
% plot(inertmap7(:, 2), inertmap7(:, 1), 'k')
% hold off
% hold on
% plot(inertmap7(:, 6), inertmap7(:, 5), 'k*')
% hold off
% 
% hold on
% plot(L*ones(1, 4), -0.5:2.5, 'm')
% hold off
% hold on
% plot(0*ones(1, 4), -0.5:2.5, 'm')
% hold off