function [statemap, varargout] = simplesim(IC, Param, iter)


T = Param(1);
W = Param(2);
S = Param(3);
w = sqrt(9.81/0.4);


bx = S/(exp(w*T)-1);
bz = W/(exp(w*T)+1);

A = [cosh(w*T) sinh(w*T)/w; w*sinh(w*T) cosh(w*T)];
B = [0 1/w; 0 -1];
C = [0 -1/w; 0 1];
statemap = IC;
inertmap = IC;

for i = 1:iter

    uz = inertmap(i, 2) + inertmap(i, 4)/w + (-1)^i * bz;
    ux = inertmap(i, 1) + inertmap(i, 3)/w - bx;

    if(i == 1)
        uz = 0;
        ux = 0;
    end

    zi = B*A*transpose(statemap(i, [2, 4])) + [bz; 0];
    xi = C*A*transpose(statemap(i, [1, 3])) + [bx; 0];

    zt = A*transpose(statemap(i, [2, 4]));
    xt = A*transpose(statemap(i, [1, 3]));

    xinert = xt(1) + ux;
    zinert = (-1)^(i-1) * zt(1) + uz;

    statemap(i+1, :) = [xi(1), zi(1), xi(2), zi(2)];
    inertmap(i+1, :) = [xinert, zinert, xi(2), (-1)^i * zi(2)];
    coplist(i, :) = [ux, uz];
end

coplist = [coplist; 0 0];

varargout = {[inertmap, coplist]};


end